#ifndef NAMES_H
#define NAMES_H

#if defined PLANAR
  #define MKID(id,sfx)          id##_##sfx##_p
#elif defined (INTERLEAVED)
  #define MKID(id,sfx)          id##_##sfx##_i
#else
  #error undefined format
#endif

#if defined (i16)
  #undef i16
  #define T                     int16_t
  #define ID(id)                MKID(id,i16)
#elif defined (i32)
  #undef i32
  #define T                     int32_t
  #define ID(id)                MKID(id,i32)
#elif defined f32
  #undef f32
  #define                       FLOAT
  #define T                     float
  #define ID(id)                MKID(id,f32)
#elif defined f64
  #undef f64
  #define                       FLOAT
  #define T                     double
  #define ID(id)                MKID(id,f64)
#else
  #error undefined format
#endif

#endif // NAMES_H
