#include "plugin.h"
#include "names.h"

static size_t ID(samplebuf_16_add)(double q, char **wpp, char *wmp,
    T **rpp, T *mrp)
{
  char *wp;
  T *rp;
  int size;
  int32_t s;
  char *sp;
#if ! defined (FLOAT)
  double qn;
#endif

  wp=*wpp;
  rp=*rpp;
#if defined (FLOAT)
  q*=(double)(0x10000>>1)-(1.0+DITHERA);
#else
  qn=q/0x10000;
#endif

  for (;;) {
    if (wp<wmp&&rp<mrp) {
#if defined (FLOAT)
      s=round(q**rp++);
      sp=(char *)&s;
#else
      s=*rp++;
	  s<<=((sizeof s)-(sizeof *rp))<<3;
      sp=(char *)&s;

      if (1.0==q&&0==sp[0]&&0==sp[1])
        s>>=16;
      else
        s=round(qn*s);
#endif
      *wp++=*sp++;
      *wp++=*sp++;
    }
    else {
      size=*rpp-rp;
      *rpp=rp;
      *wpp=wp;

      return size;
    }
  }
}

static size_t ID(samplebuf_24_add)(double q, char **wpp, char *mwp,
    T **rpp, T *mrp)
{
  char *wp;
  T *rp;
  int size;
  int32_t s;
  char *sp;
#if ! defined (FLOAT)
  double qn;
#endif

  wp=*wpp;
  rp=*rpp;
#if defined (FLOAT)
  q*=(0x1000000>>1)-1;
#else
  qn=q/0x100;
#endif

  for (;;) {
    if (wp<mwp&&rp<mrp) {
#if defined (FLOAT)
      s=round(q**rp++);
      sp=(char *)&s;
#else
      s=*rp++;
	  s<<=((sizeof s)-(sizeof *rp))<<3;
      sp=(char *)&s;

      if (1.0==q&&0==sp[0])
        s>>=8;
      else
        s=round(qn*s+DITHER());
#endif
      *wp++=*sp++;
      *wp++=*sp++;
      *wp++=*sp++;
    }
    else {
      size=*rpp-rp;
      *rpp=rp;
      *wpp=wp;

      return size;
    }
  }
}

size_t ID(samplebuf_add)(samplebuf_t *buf, double q, T **rpp, T *mrp)
{
  size_t size=mrp-*rpp;

  if (SAMPLEBUF_DONE==samplebuf_wait_write(buf))
    return 0;

  for (;;) {
    switch (buf->bps) {
      case 16:
        ID(samplebuf_16_add)(q,&buf->wp,buf->mp,rpp,mrp);
        break;
      case 24:
        ID(samplebuf_24_add)(q,&buf->wp,buf->mp,rpp,mrp);
        break;
      default:
        return 0;
    }

    if (buf->wp==buf->mp)
      samplebuf_signal_read(buf);

    if (*rpp==mrp)
      return size;
    else if (SAMPLEBUF_DONE==samplebuf_wait_write(buf))
      return 0;
  }
}
